import config
from Sprite import MovingSprite

class MissileInfo:
	def __init__(self, name, fly_sprite, fly_left, fly_right, blow_sprite, blow_left, blow_right):
		self.name = name
		self.fly_sprite = fly_sprite
		self.fly_left = fly_left
		self.fly_right = fly_right
		
		self.blow_sprite = blow_sprite
		self.blow_left = blow_left
		self.blow_right = blow_right

class Missile(MovingSprite):
	def __init__(self, kind, level, to_left, damage = 40, speed = 100, fps = None):
		if to_left:
			MovingSprite.__init__(self, kind.fly_sprite, kind.fly_left, fps)
		else:
			MovingSprite.__init__(self, kind.fly_sprite, kind.fly_right, fps)
		
		self.to_left = to_left
		self.kind = kind
		self.level = level
		self.damage = damage
		self.speed = speed
	
	def getSpeed(self): return self.speed

class Fireball(Missile):
	def __init__(self, level, to_left, fps = None):
		Missile.__init__(self,
			missile_types["fireball"],
			level,
			to_left,
			50 * level,
			100 + 50*level,
			fps
		)

class Iceball(Missile):
	def __init__(self, level, to_left, fps = None):
		Missile.__init__(self,
			missile_types["iceball"],
			level,
			to_left,
			33 * level, 
			150 + 25*level,
			fps
		)

missile_types = {
	"fireball" : MissileInfo("fireball", "energyball", "fireball_fly_left", "fireball_fly_right", "blow", "fireball", "fireball"),
	"iceball" : MissileInfo("iceball", "energyball", "iceball_fly_left", "iceball_fly_right", "blow", "iceball", "iceball")
}

